# include "minigui.ch"

**********************************************************************************************************
FUNCTION connect2db(dbname,lCreate)
**********************************************************************************************************
dbo := sqlite3_open(dbname,lCreate)
	IF Empty( dbo )
	   msginfo("Database no encontrada!")
	   RETURN .f.
	ENDIF
RETURN .t.

**********************************************************************************************************
FUNCTION sql_select(dbo1,qstr)
**********************************************************************************************************
local atable := {}

	if empty(dbo1)
	   msgstop("Erro de conexo com base de Dados!")
	   return tablearr
	endif
	
atable := sqlite3_get_table(dbo1,qstr)

	if sqlite3_errcode(dbo1) > 0 // error
	   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
	   return nil
	endif 
	
return atable

**********************************************************************************************************
FUNCTION sql_cmd(dbo1,qstr)
**********************************************************************************************************
if empty(dbo1)
   msgstop("Database Connection Error!")
   return .f.
endif

sqlite3_exec(dbo1,qstr)

if sqlite3_errcode(dbo1) > 0 // error
   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
   return .f.
endif 
return .t.

**********************************************************************************************************
FUNCTION C2SQL(Value)
**********************************************************************************************************

   local cValue := ""
    local cFormatoDaData := set(4)
   do case
      case Valtype(Value) == "N"
         cValue := AllTrim(Str(Value))

      case Valtype(Value) == "D"
         if !Empty(Value)
            cdate := dtos(value)
            cValue := "'"+substr(cDate,1,4)+"-"+substr(cDate,5,2)+"-"+substr(cDate,7,2)+"'"
         else
            cValue := "''"
         endif

      case Valtype(Value) $ "CM"
         IF Empty( Value)
            cValue="''"
         ELSE
            cValue := "'" + value+ "'"
         ENDIF

      case Valtype(Value) == "L"
         cValue := AllTrim(Str(iif(Value == .F., 0, 1)))

      otherwise
         cValue := "''"       // NOTE: Here we lose values we cannot convert

   endcase

return cValue



*******************************************************************************************************************
Function sqlQueryUpDate(dbo1,aUpdate,aStruc)
*******************************************************************************************************************
Local cUpdate := ""
Local I := 0
Local cValue := ""
//msginfo(STR(LEN(aUpdate)) +"  /  " + STR(Len(aStruc)) )

 IF 	LEN(aUpdate) == LEN(aStruc)				
                        
        FOR I := 1 TO LEN(aStruc) 
		
			DO CASE 
				CASE VALTYPE(aUpdate[i]) == "N"  && dados tipo numericos
				//msginfo("NUMERO")
						cValue := AllTrim(STR(aUpdate[i]))
						cUpdate +=  aStruc[i] + " = " +  cValue + ","
		  
				CASE VALTYPE(aUpdate[i]) == "D" && dados tipo data
				//msginfo("DATA")
					IF !Empty(aUpdate[i])
					// MySQL dates are like YYYY-MM-DD
						cValue := "'"+STRZERO(YEAR(aUpdate[i]), 4) + "-" + STRZERO(MONTH(aUpdate[i]), 2) + "-" + STRZERO(DAY(aUpdate[i]), 2) + "'"
						cUpdate +=  aStruc[i] + " = " +  cValue + ","
					ELSE
						cValue := "'0000-00-00'"
						cUpdate +=  aStruc[i] + " = " +  cValue + ","
					ENDIF
						
				CASE VALTYPE(aUpdate[i]) $ "CM" && dados tipo string
					//msginfo("STRING")
					// msginfo(STR(i) +" / "+ aStruc[i])
					IF aUpdate[i] != "OFF"
            
						IF 	aUpdate[i] == "NULL" 
							cValue := "NULL"
						Else
						
							IF 	SUBSTR(aStruc[i],1,4) == "foto" && para funcionar tem que criar o campo long_blob com nome inciando com foto
                                cValue := "'" + aUpdate[i] + "'"
								//msginfo(cValue)
								//msginfo(SUBSTR(aStruc[i],1,4))
							ELSE
								cValue := Alltrim(sql_escape(aUpdate[i]))
								cValue := "'" + cValue + "'"
								//msginfo(SUBSTR(aStruc[i],1,4))
								//msginfo(cValue)
							ENDIF
						ENDIF
								cUpdate +=  aStruc[i] + " = " +  cValue + ","
					ENDIF

	
				CASE VALTYPE(aUpdate[i]) == "L"
					//msginfo("LOGICO")
						cValue := AllTrim(STR(IIF( aUpdate[i] == .F., 0, 1)))
						cUpdate +=  aStruc[i] + " = " +  cValue + ","
				OTHERWISE
				//msginfo("QUALQUER VALOR")
						cValue := "''"       // NOTE: Here we lose values we cannot convert
						cUpdate +=  aStruc[i] + " = " +  cValue + ","

				ENDCASE		
		
		NEXT
					cUpdate := Left(cUpdate, Len(cUpdate) -1) 

ELSE

    MSGINFO("Campos diferentes da Estrutura da Table")

ENDIF
	
    
Return(cUpdate)



*******************************************************************************************************************
Function sqlQueryInsert(dbo1,aInsert,aStruc)
*******************************************************************************************************************
Local cInsert := ""
Local cCampo := ""
Local cRetono := ""
Local I := 0
Local cValue := ""
//msginfo(STR(LEN(aUpdate)) +"  /  " + STR(Len(aStruc)) )

 IF 	LEN(aInsert) == LEN(aStruc)				
                        
        FOR I := 1 TO LEN(aStruc) 
		
			DO CASE 
				CASE VALTYPE(aInsert[i]) == "N"  && dados tipo numericos
				//msginfo("NUMERO")
						cValue := AllTrim(STR(aInsert[i]))
						cInsert +=  cValue + ","
						cCampo += aStruc[i] + ","
		  
				CASE VALTYPE(aInsert[i]) == "D" && dados tipo data
				//msginfo("DATA")
					IF !Empty(aInsert[i])
					// MySQL dates are like YYYY-MM-DD
						cValue := "'"+STRZERO(YEAR(aInsert[i]), 4) + "-" + STRZERO(MONTH(aInsert[i]), 2) + "-" + STRZERO(DAY(aInsert[i]), 2) + "'"
						cInsert +=  cValue + ","
						cCampo += aStruc[i] + ","
					ELSE
						cValue := "'0000-00-00'"
						cInsert +=  cValue + ","
						cCampo += aStruc[i] + ","
					ENDIF
				
			
				CASE VALTYPE(aInsert[i]) $ "CM" && dados tipo string
					//msginfo("STRING")
					// msginfo(STR(i) +" / "+ aStruc[i])
					IF aInsert[i] != "OFF"
 
					IF 	aInsert[i] == "NULL" 
							cValue := "NULL"
					Else
							IF 	SUBSTR(aStruc[i],1,4) == "foto" && para funcionar tem que criar o campo long_blob com nome inciando com foto
                                cValue := "'" + aInsert[i] + "'"
							ELSE
								cValue := Alltrim(sql_escape( aInsert[i]))
								cValue := "'" + cValue + "'"

							ENDIF

					ENDIF
								cInsert +=  cValue + ","
								cCampo += aStruc[i] + ","
					ENDIF

	
				CASE VALTYPE(aInsert[i]) == "L"
					//msginfo("LOGICO")
						cValue := AllTrim(STR(IIF(aInsert[i] == .F., 0, 1)))
						cInsert +=  cValue + ","
						cCampo += aStruc[i] + ","
				OTHERWISE
				//msginfo("QUALQUER VALOR")
						cValue := "''"       // NOTE: Here we lose values we cannot convert
						cInsert +=  cValue + ","
						cCampo += aStruc[i] + ","

				ENDCASE		
		
		NEXT
					cInsert := Left(cInsert, Len(cInsert) -1) 
					cCampo := Left(cCampo, Len(cCampo) -1)
					cRetono := "(" + cCampo + ") Values (" + cInsert + ")"

ELSE

    MSGINFO("Campos diferentes da Estrutura da Table")

ENDIF
	
    
Return(cRetono)

*************************************************************************************************************************************
FUNCTION sql_escape( cStr )
*************************************************************************************************************************************

   local cStrNew := "", nX
   Local cString := ""
   aCaracterEscape := {"'",'"',"\"}
   aEscape  := {"\'",'\"','\\'}
 

			FOR i:= 1 TO LEN(cStr)
					cString :=  SUBSTR(cStr,i,1) 
					//msginfo(cString)
					nPos_CharEscape := ASCAN(aCaracterEscape,cString)
					if nPos_CharEscape > 0
						//msginfo("igual : " + aCaracterEscape[nPos_CharEscape] + "Pos :" + STR(nPos_CharEscape) )
						cStrNew := cStrNew + aEscape[nPos_CharEscape]
						
					else
						cStrNew :=  cStrNew + cString
					endif
					//msgdebug( Pos ,I, cStrNew )
			NEXT
 //msgdebug('final'  ,cStrNew )

Return( cStrNew )
